/*
** config.hh
** Login : <nico@Altarion.marmotte.ath.cx>
** Started on  Tue Dec  3 21:23:01 2002 Nicolas
** $Id: config.hh,v 1.1 2002/12/09 11:26:50 speedblue Exp $
** 
** Copyright (C) 2002 Nicolas
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef   	CONFIG_HH_
# define   	CONFIG_HH_

#include &lt;iostream&gt;
#include &lt;Parameters.hh&gt;
#include &lt;Config.hh&gt;
#include &lt;string&gt;

namespace Data
{
  class Config
  {
   public:
    Config()
    {}

    const Parameters&	get_param() const {return _param; }
    Parameters&		get_param() {return _param; }
    void		set_param(const Parameters& param) {_param = param; }

    const std::list<Variable>&	get_vars() const {return _vars; }
    std::list<Variable>&	get_vars() {return _vars; }
    void			set_vars(const std::list<Variable>& vars) 
    {_vars = vars; }
    void			add_vars(const Variable& vars) 
    { _vars.push_back(vars); }

   protected:
    Parameters			_param;
    std::list<Variable>		_vars;

  };

  //Code outside classe declaration
  inline std::ostream& operator<<(std::ostream& s, const Config& v)
  {  
    v.get_param().print(s);
    for (std::list<Variable>::const_iterator it = _vars.begin();
	 it != _vars.end(); ++it)
      it->print(s);
    return s;
  }
}

#endif	    /* !CONFIG_HH_ */
